<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAddOnFeatureEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfAddOnFeatureEnum extends AbstractStructArrayBase
{
    /**
     * The AddOnFeatureEnum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $AddOnFeatureEnum;
    /**
     * Constructor method for ArrayOfAddOnFeatureEnum
     * @uses ArrayOfAddOnFeatureEnum::setAddOnFeatureEnum()
     * @param string[] $addOnFeatureEnum
     */
    public function __construct(array $addOnFeatureEnum = array())
    {
        $this
            ->setAddOnFeatureEnum($addOnFeatureEnum);
    }
    /**
     * Get AddOnFeatureEnum value
     * @return string[]|null
     */
    public function getAddOnFeatureEnum()
    {
        return $this->AddOnFeatureEnum;
    }
    /**
     * This method is responsible for validating the values passed to the setAddOnFeatureEnum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddOnFeatureEnum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAddOnFeatureEnumForArrayConstraintsFromSetAddOnFeatureEnum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAddOnFeatureEnumAddOnFeatureEnumItem) {
            // validation for constraint: enumeration
            if (!\CustomerManagement\EnumType\AddOnFeatureEnum::valueIsValid($arrayOfAddOnFeatureEnumAddOnFeatureEnumItem)) {
                $invalidValues[] = is_object($arrayOfAddOnFeatureEnumAddOnFeatureEnumItem) ? get_class($arrayOfAddOnFeatureEnumAddOnFeatureEnumItem) : sprintf('%s(%s)', gettype($arrayOfAddOnFeatureEnumAddOnFeatureEnumItem), var_export($arrayOfAddOnFeatureEnumAddOnFeatureEnumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\AddOnFeatureEnum', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \CustomerManagement\EnumType\AddOnFeatureEnum::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AddOnFeatureEnum value
     * @uses \CustomerManagement\EnumType\AddOnFeatureEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\AddOnFeatureEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $addOnFeatureEnum
     * @return \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum
     */
    public function setAddOnFeatureEnum(array $addOnFeatureEnum = array())
    {
        // validation for constraint: array
        if ('' !== ($addOnFeatureEnumArrayErrorMessage = self::validateAddOnFeatureEnumForArrayConstraintsFromSetAddOnFeatureEnum($addOnFeatureEnum))) {
            throw new \InvalidArgumentException($addOnFeatureEnumArrayErrorMessage, __LINE__);
        }
        $this->AddOnFeatureEnum = $addOnFeatureEnum;
        return $this;
    }
    /**
     * Add item to AddOnFeatureEnum value
     * @uses \CustomerManagement\EnumType\AddOnFeatureEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\AddOnFeatureEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum
     */
    public function addToAddOnFeatureEnum($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\AddOnFeatureEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\AddOnFeatureEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \CustomerManagement\EnumType\AddOnFeatureEnum::getValidValues())), __LINE__);
        }
        $this->AddOnFeatureEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \CustomerManagement\EnumType\AddOnFeatureEnum::valueIsValid()
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfAddOnFeatureEnum
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\AddOnFeatureEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\AddOnFeatureEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \CustomerManagement\EnumType\AddOnFeatureEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AddOnFeatureEnum
     */
    public function getAttributeName()
    {
        return 'AddOnFeatureEnum';
    }
}
